Attribute VB_Name = "modConfiguration"
Option Explicit

Public Const APP_NAME As String = "telnetrecon 0.1"
Public Const APP_WEBSITE_URL As String = "http://www.computec.ch/projekte/telnetrecon/"
Public Const APP_COPYRIGHT_OWNER As String = "telnetrecon project"

Public Const PROJECT_WEBSERVER As String = "www.computec.ch"
Public Const PROJECT_WEBPORT As Long = 80
Public Const PROJECT_WEBUPLOAD_FILE As String = "/projekte/telnetrecon/?s=upload"

Public Const PROJECT_WEBDB As String = "http://www.computec.ch/projekte/telnetrecon/?s=database"

Public app_configuration_filename As String

Public req_timeout_connect As Integer

Public Sub LoadConfigFromFile(Optional ByRef sConfigurationFileName As String)
    Dim iFreeFile As Integer
    Dim sTempString As String
    
    Dim scan_targethostV As Boolean
    Dim scan_targetportV As Boolean
    Dim app_hitpoints_minimumV As Boolean
    Dim app_hitpoints_maximumV As Boolean
    Dim req_timeout_connectV As Boolean
    Dim req_timeout_sendV As Boolean
    Dim req_timeout_receiveV As Boolean
        
    If (LenB(sConfigurationFileName)) Then
        app_configuration_filename = sConfigurationFileName
    Else
        app_configuration_filename = App.Path & "\config\default.cfg"
    End If
    
    If (Dir$(app_configuration_filename, 16) <> "") Then
        iFreeFile = FreeFile
        Open app_configuration_filename For Input As #iFreeFile
            Do While Not EOF(iFreeFile)
                Line Input #iFreeFile, sTempString
                
                If (Left$(sTempString, 1) <> "#") Then
                    If (InStrB(1, sTempString, "=", vbBinaryCompare)) Then
                        If (Left$(sTempString, 16) = "scan_targethost=") Then
                            scan_targethost = Mid$(sTempString, 17, Len(sTempString))
                            If (LenB(scan_targethost)) Then
                                scan_targethostV = True
                            End If
                        ElseIf (Left$(sTempString, 16) = "scan_targetport=") Then
                            scan_targetport = Val(Mid$(sTempString, 17, Len(sTempString)))
                            If (LenB(scan_targetport)) Then
                                scan_targetportV = True
                            End If
                        ElseIf (Left$(sTempString, 22) = "app_hitpoints_minimum=") Then
                            app_hitpoints_minimum = Val(Mid$(sTempString, 23, Len(sTempString)))
                            If (LenB(app_hitpoints_minimum)) Then
                                app_hitpoints_minimumV = True
                            End If
                        ElseIf (Left$(sTempString, 22) = "app_hitpoints_maximum=") Then
                            app_hitpoints_maximum = Val(Mid$(sTempString, 23, Len(sTempString)))
                            If (LenB(app_hitpoints_maximum)) Then
                                app_hitpoints_maximumV = True
                            End If
                        End If
                    End If
                End If
            Loop
        Close
    End If

    If scan_targethostV = False Then
        scan_targethost = "127.0.0.1"
    End If
    
    If scan_targetportV = False Or scan_targetport < 1 Or scan_targetport > 65535 Then
        scan_targetport = 23
    End If

    If app_hitpoints_minimumV = False Or app_hitpoints_minimum < 1 Or app_hitpoints_minimum > 20 Then
        app_hitpoints_minimum = 2
    End If
    
    If app_hitpoints_maximumV = False Or app_hitpoints_maximum < 1 Or app_hitpoints_maximum > 20 Then
        app_hitpoints_maximum = 8
    End If
End Sub

Public Sub WriteConfigurationToFile(ByRef sConfigurationFileName As String)
    Dim iFreeFile As Integer
    Dim cConfigContent As Concat
    
    Set cConfigContent = New Concat
    
    app_configuration_filename = sConfigurationFileName
    Call ChangeStatusBar("Save configuration to " & app_configuration_filename & ".")
    
    cConfigContent.Concat _
        "# " & APP_NAME & " configuration file" & vbNewLine & _
        "# " & vbNewLine & _
        "#   Date   " & Date & vbNewLine & _
        "#   Time   " & Time & vbNewLine & _
        "#   File   " & app_configuration_filename & vbNewLine & _
        "#   User   " & GetLocalUsername & vbNewLine & _
        "#" & vbNewLine

    cConfigContent.Concat _
        "# Disclaimer: This config file is generated automatically by the software" & vbNewLine & _
        "# itself during runtime. Please do not manually edit these values unless you" & vbNewLine & _
        "# do know what you are doing. Manual changes work only if the application is" & vbNewLine & _
        "# not running." & vbNewLine & _
        "#" & vbNewLine & _
        "# See the online help, documentation and the official project web site at" & vbNewLine & _
        "# " & APP_WEBSITE_URL & " for more details." & vbNewLine & vbNewLine
    
    cConfigContent.Concat "# Scan" & vbNewLine
    cConfigContent.Concat "scan_targethost=" & scan_targethost & vbNewLine
    cConfigContent.Concat "scan_targetport=" & scan_targetport & vbNewLine
    cConfigContent.Concat vbNewLine
    cConfigContent.Concat "# Statistics" & vbNewLine
    cConfigContent.Concat "app_hitpoints_minimum=" & app_hitpoints_minimum & vbNewLine
    cConfigContent.Concat "app_hitpoints_maximum=" & app_hitpoints_maximum & vbNewLine
    cConfigContent.Concat vbNewLine
    
    On Error Resume Next
    iFreeFile = FreeFile
    Open sConfigurationFileName For Output As #iFreeFile
        Print #iFreeFile, cConfigContent.Value
    Close
    
    Call ChangeStatusBarDone
End Sub

Public Function Rand(ByRef lLow As Long, ByRef lHigh As Long) As Long
    Rand = Int((lHigh - lLow + 1) * Rnd) + lLow
End Function
